Merge "lib.sh: Fix compatibility with bash 4.2"
[fuel.git] / mcp / scripts / lib.sh
index 650c63b..b4d45dd 100644 (file)
@@ -1,9 +1,16 @@
-#!/bin/bash
+#!/bin/bash -e
+##############################################################################
+# Copyright (c) 2017 Mirantis Inc., Enea AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
 #
 # Library of shell functions
 #
 
-generate_ssh_key() {
+function generate_ssh_key {
   # shellcheck disable=SC2155
   local mcp_ssh_key=$(basename "${SSH_KEY}")
   local user=${USER}
@@ -20,7 +27,7 @@ generate_ssh_key() {
   sudo install -D -o "${user}" -m 0600 "${mcp_ssh_key}" "${SSH_KEY}"
 }
 
-get_base_image() {
+function get_base_image {
   local base_image=$1
   local image_dir=$2
 
@@ -28,7 +35,7 @@ get_base_image() {
   wget -P "${image_dir}" -N "${base_image}"
 }
 
-cleanup_vms() {
+function cleanup_vms {
   # clean up existing nodes
   for node in $(virsh list --name | grep -P '\w{3}\d{2}'); do
     virsh destroy "${node}"
@@ -40,10 +47,10 @@ cleanup_vms() {
   done
 }
 
-prepare_vms() {
-  local -n vnodes=$1
-  local base_image=$2
-  local image_dir=$3
+function prepare_vms {
+  local base_image=$1; shift
+  local image_dir=$1; shift
+  local vnodes=("$@")
 
   cleanup_vms
   get_base_image "${base_image}" "${image_dir}"
@@ -60,8 +67,8 @@ prepare_vms() {
   done
 }
 
-create_networks() {
-  local -n vnode_networks=$1
+function create_networks {
+  local vnode_networks=("$@")
   # create required networks, including constant "mcpcontrol"
   # FIXME(alav): since we renamed "pxe" to "mcpcontrol", we need to make sure
   # we delete the old "pxe" virtual network, or it would cause IP conflicts.
@@ -72,7 +79,7 @@ create_networks() {
       virsh net-undefine "${net}"
     fi
     # in case of custom network, host should already have the bridge in place
-    if [ -f "net_${net}.xml" ]; then
+    if [ -f "net_${net}.xml" ] && [ ! -d "/sys/class/net/${net}/bridge" ]; then
       virsh net-define "net_${net}.xml"
       virsh net-autostart "${net}"
       virsh net-start "${net}"
@@ -80,51 +87,46 @@ create_networks() {
   done
 }
 
-create_vms() {
-  local -n vnodes=$1
-  local -n vnodes_ram=$2
-  local -n vnodes_vcpus=$3
-  local -n vnode_networks=$4
-  local image_dir=$5
+function create_vms {
+  local image_dir=$1; shift
+  IFS='|' read -r -a vnodes <<< "$1"; shift
+  local vnode_networks=("$@")
 
   # AArch64: prepare arch specific arguments
   local virt_extra_args=""
   if [ "$(uname -i)" = "aarch64" ]; then
-    # No Cirrus VGA on AArch64, use vga std
-    virt_extra_args="$virt_extra_args --video=vga"
+    # No Cirrus VGA on AArch64, use virtio instead
+    virt_extra_args="$virt_extra_args --video=virtio"
   fi
 
   # create vms with specified options
-  for node in "${vnodes[@]}"; do
+  for serialized_vnode_data in "${vnodes[@]}"; do
+    IFS=',' read -r -a vnode_data <<< "${serialized_vnode_data}"
+
     # prepare network args
     net_args=" --network network=mcpcontrol,model=virtio"
-    if [ "${node}" = "mas01" ]; then
+    if [ "${vnode_data[0]}" = "mas01" ]; then
       # MaaS node's 3rd interface gets connected to PXE/Admin Bridge
       vnode_networks[2]="${vnode_networks[0]}"
     fi
     for net in "${vnode_networks[@]:1}"; do
-      net_type="network"
-      # in case of custom network, host should already have the bridge in place
-      if [ ! -f "net_${net}.xml" ]; then
-        net_type="bridge"
-      fi
-      net_args="${net_args} --network ${net_type}=${net},model=virtio"
+      net_args="${net_args} --network bridge=${net},model=virtio"
     done
 
     # shellcheck disable=SC2086
-    virt-install --name "${node}" \
-    --ram "${vnodes_ram[$node]}" --vcpus "${vnodes_vcpus[$node]}" \
+    virt-install --name "${vnode_data[0]}" \
+    --ram "${vnode_data[1]}" --vcpus "${vnode_data[2]}" \
     --cpu host-passthrough --accelerate ${net_args} \
-    --disk path="${image_dir}/mcp_${node}.qcow2",format=qcow2,bus=virtio,cache=none,io=native \
+    --disk path="${image_dir}/mcp_${vnode_data[0]}.qcow2",format=qcow2,bus=virtio,cache=none,io=native \
     --os-type linux --os-variant none \
     --boot hd --vnc --console pty --autostart --noreboot \
-    --disk path="${image_dir}/mcp_${node}.iso",device=cdrom \
+    --disk path="${image_dir}/mcp_${vnode_data[0]}.iso",device=cdrom \
     --noautoconsole \
     ${virt_extra_args}
   done
 }
 
-update_mcpcontrol_network() {
+function update_mcpcontrol_network {
   # set static ip address for salt master node, MaaS node
   # shellcheck disable=SC2155
   local cmac=$(virsh domiflist cfg01 2>&1| awk '/mcpcontrol/ {print $5; exit}')
@@ -136,8 +138,8 @@ update_mcpcontrol_network() {
     "<host mac='${amac}' name='mas01' ip='${MAAS_IP}'/>" --live
 }
 
-start_vms() {
-  local -n vnodes=$1
+function start_vms {
+  local vnodes=("$@")
 
   # start vms
   for node in "${vnodes[@]}"; do
@@ -146,16 +148,16 @@ start_vms() {
   done
 }
 
-check_connection() {
+function check_connection {
   local total_attempts=60
   local sleep_time=5
-  local attempt=1
 
   set +e
   echo '[INFO] Attempting to get into Salt master ...'
 
   # wait until ssh on Salt master is available
-  while ((attempt <= total_attempts)); do
+  # shellcheck disable=SC2034
+  for attempt in $(seq "${total_attempts}"); do
     # shellcheck disable=SC2086
     ssh ${SSH_OPTS} "ubuntu@${SALT_MASTER}" uptime
     case $? in
@@ -163,12 +165,11 @@ check_connection() {
       *) echo "${attempt}/${total_attempts}> ssh server ain't ready yet, waiting for ${sleep_time} seconds ..." ;;
     esac
     sleep $sleep_time
-    ((attempt+=1))
   done
   set -e
 }
 
-parse_yaml() {
+function parse_yaml {
   local prefix=$2
   local s
   local w
@@ -176,7 +177,7 @@ parse_yaml() {
   s='[[:space:]]*'
   w='[a-zA-Z0-9_]*'
   fs="$(echo @|tr @ '\034')"
-  sed -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
+  sed -e 's|---||g' -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
       -e "s|^\($s\)\($w\)$s[:-]$s\(.*\)$s\$|\1$fs\2$fs\3|p" "$1" |
   awk -F"$fs" '{
   indent = length($1)/2;
@@ -188,3 +189,20 @@ parse_yaml() {
       }
   }' | sed 's/_=/+=/g'
 }
+
+function wait_for {
+  # Execute in a subshell to prevent local variable override during recursion
+  (
+    local total_attempts=$1; shift
+    local cmdstr=$*
+    local sleep_time=10
+    echo "[NOTE] Waiting for cmd to return success: ${cmdstr}"
+    # shellcheck disable=SC2034
+    for attempt in $(seq "${total_attempts}"); do
+      # shellcheck disable=SC2015
+      eval "${cmdstr}" && return 0 || true
+      echo -n '.'; sleep "${sleep_time}"
+    done
+    return 1
+  )
+}